;specjalnie do porzdkowania danych z c:Szu typu "100-80" "250-200"
;redukuje nadmiar kocw wierszy w danych
(defun c:szu2 ( / sc_d#w id#w tablica#w tablica1#w rzad#w p#w i#w plik#w plik1#w licznik#w)

(setq sc_d#w "C:/!Wentyle/WentyleSpiro/WentyleSpiroRLL/"
	plik#w "RLL_zmniejsza1.txt"
	plik1#w "RLL_zmniejsza2.txt")

    ;dane z pliku#w ...txt  do tablic#wy
    (setq id#w (open (strcat sc_d#w  plik#w) "r"))
    (setq tablica#w '())
    (while (setq rzad#w (read-line id#w)) (progn
    (setq tablica#w (append  tablica#w (list rzad#w)))
                                   ))
    (setq id#w (close id#w))

(setq p#w ""  licznik#w 1  tablica1#w '())
(while tablica#w 
(progn
(setq p#w (strcat p#w (car tablica#w)))
(if (or (= licznik#w 30)(= (length tablica#w) 1) )
	(setq tablica1#w (append tablica1#w (list p#w))
			 	 p#w "" 
				 licznik#w 0))
(setq 	licznik#w (+ licznik#w 1)
	tablica#w (cdr tablica#w))
));progn/while


    (setq id#w (open (strcat sc_d#w  plik1#w) "w"))
    (foreach i#w tablica1#w
    (progn
    (write-line i#w id#w)
    ))
    (setq id#w (close id#w))

(prompt "OK!")
(princ)
);defun






;----------
;FrLa - wykonuje FREEZE warstwy, na ktorej lezy wskazany obiekt
;----------
;
(defun C:FRLA (/ e n)
    (setq e (car (entsel "\nPokaz obiekt  warstwy do zamrozenia...")))
    (if e (progn
         (setq e (entget e ))
         (setq n (cdr (assoc 8 e)))
         (command "_LAYER" "_FREEZE" n "")
    ))
)
;
;
;----------
;GoLa - przenosi wskazane obiekty na layer,
;                                 na ktorym znajduje sie drugi wskazany obiekt.
;----------
;
(defun C:GOLA (/ ss e n)
    (princ "Pokaz przenoszone obiekty... \n")
    (setq ss (ssget))
    (if ss (progn
         (setq e (car (entsel "Pokaz obiekt na warstwie docelowej...")))
         (if e (progn
            (setq e (entget e))
            (setq n (cdr (assoc 8 e)))
            (command "_CHANGE" ss "" "_PROP" "_LAYER" n "")
         ))
     ))
)
;
;
;----------
;SetLa - zmienia aktywny layer na ten, do ktorego nalezy wskazany obiekt.
;----------
;
(defun C:SETLA (/ e n)
    (setq e (car (entsel"\nPokaz obiekt dla nowej aktywnej kalki ...")))
    (if e (progn
         (setq e (entget e))
         (setq n (cdr (assoc 8 e)))
         (command "_LAYER" "_SET" n"")
    ))
)




(defun c:cc () (load "Wentyle_NARZEDZIOWE"))

(regapp "PUNKT_W")	
(regapp "WYNIK_W")
(regapp "KOLEJ_W")


;---------------------------------------------------------------------------------------
;GRUPA PROCEDUR (jednorazowe) SKANOWANIA SPADKW CINIE PRZEWODU OKRGEGO/PROSTOKTNEGO
;wstawia punkty na osi X (Warstwa KANT)
;podawane w kolejnoci od wartoci min (mona przerywa podawanie i kasowa bdnie podane)
(defun c:AosX ( / p0#w p#w listpkz#w pr#w)
(command "_LAYER" "_s" "KANT" "_u" "KANT" "")
(command "_UCS" "")

(while (setq p0#w (getpoint "\n>Wska punkt..."))
(progn
(command "_POINT" p0#w)
(setq p#w (getstring "Podaj warto "))
(command "_TEXT" "_j" "_mr" (getvar "lastpoint") "1.3" "0" (strcat p#w " ") "")

(setq listpkz#w (list "PUNKT_W")
      listpkz#w (append listpkz#w (list (cons 1000 p#w))))
(setq pr#w  (list -3 listpkz#w ));list/setq
(setq pr#w (append (entget (entlast)) (list pr#w)))(entmod pr#w)

));while
);defun




;wstawia punkty wydajnoci (warstwa 00)
;podawane w kolejnoci od wartoci min (mona przerywa podawanie i kasowa bdnie podane)
(defun c:AWYD ( / p0#w p#w listpkz#w pr#w)
(command "_LAYER" "_s" "00" "_u" "00"  "")
(command "_UCS" "")

(while (setq p0#w (getpoint "\n>Wska punkt..."))
(progn
(command "_POINT" p0#w)
(setq p#w (getstring " Podaj wydajno "))
(command "_TEXT" "_j" "_mr" (getvar "lastpoint") "1.3" "0" (strcat p#w " ") "")

(setq listpkz#w (list "KOLEJ_W")
      listpkz#w (append listpkz#w (list (cons 1000 p#w))))
(setq pr#w  (list -3 listpkz#w ));list/setq
(setq pr#w (append (entget (entlast)) (list pr#w)))(entmod pr#w)

));while
);defun


;rysuje punkty osi liniowych spadkw cinie (KANT1)
;podawane w kolejnoci od wartoci min (mona przerywa podawanie i kasowa bdnie podane)
(defun c:AosY ( / p0#w p#w listpkz#w pr#w)
(command "_LAYER" "_s" "KANT1" "_u" "KANT1" "")
(command "_UCS" "")

(while (setq p0#w (getpoint "\n>Wska punkt..."))
(progn
(command "_POINT" p0#w)
(setq p#w (getstring "Podaj warto dPa "))
(command "_TEXT" "_j" "_mr" (getvar "lastpoint") "1.3" "0" (strcat p#w " ") "")

(setq listpkz#w (list "WYNIK_W")
      listpkz#w (append listpkz#w (list (cons 1000 p#w))))
(setq pr#w  (list -3 listpkz#w ));list/setq
(setq pr#w (append (entget (entlast)) (list pr#w)))(entmod pr#w)

));while
);defun









;tworzy tablic zalenoci
;zakada si e punkty byy podawane w kolejnoci 
(defun c:Szu ( / sel#w tabX#w Wyd#w tabY#w p#w pp#w i#w j#w k#w a#w b#w)

(setq dlugosc_linii_k#w 1000)

(command "_LAYER" "_s" "0" "")
(command "_UCS" "")

;punkty osiX do tabX#w
(setq sel#w (ssget "x" (list 
                       (cons -4 "<AND")
			     (cons 0 "TEXT") (cons 8 "KANT")  
                       (cons -4 "AND>") )))
(setq tabX#w '() i#w 0)
(repeat (sslength sel#w)
        (progn
	  (setq p#w (cdr (assoc 11 (entget (ssname sel#w i#w))))
              p#w (list (car p#w) (cadr p#w)))

        (setq tabX#w (append tabX#w (list (list 
	               (cdar (cdadr (assoc -3 (entget (ssname sel#w i#w) '("PUNKT_W")))))
			    p#w  ))))

        (setq i#w (+ i#w 1))
));progn/repeat
(setq tabX#w (reverse tabX#w) tab#w tabX#w)

;kontrola czy kolejno podawania punktw bya prawidowa
(while tab#w (progn
	(if (and (car tab#w)(cadr tab#w)
	         (>= (atof (caar tab#w)) (atof (caadr tab#w)) ))
	         (progn (alert (strcat "Niewaciwa kolejno punktw w " 
			           (caar tab#w) " " (caadr tab#w) )) (exit)));if
(setq tab#w (cdr tab#w)) ))



;punkty Osi Wydajnosci do Wyd#w
(setq sel#w nil
	sel#w (ssget "x" (list 
                       (cons -4 "<AND")
			     (cons 0 "TEXT") (cons 8 "00")  
                       (cons -4 "AND>") )))
(setq Wyd#w '() i#w 0)
(repeat (sslength sel#w)
        (progn
	  (setq p#w (cdr (assoc 11 (entget (ssname sel#w i#w))))
              p#w (list (car p#w) (cadr p#w)))

        (setq Wyd#w  (append Wyd#w (list (list 
	               (cdar (cdadr (assoc -3 (entget (ssname sel#w i#w) '("KOLEJ_W")))))
			    p#w  ))))

        (setq i#w (+ i#w 1))
));progn/repeat
(setq Wyd#w (reverse Wyd#w) tab#w Wyd#w)

;kontrola czy kolejno podawania punktw bya prawidowa
(while tab#w (progn
	(if (and (car tab#w)(cadr tab#w)
	         (>= (atof (caar tab#w)) (atof (caadr tab#w)) ))
	         (progn (alert (strcat "Niewaciwa kolejno punktw w " 
			           (caar tab#w) " " (caadr tab#w) )) (exit)));if
(setq tab#w (cdr tab#w)) ))


;punkty osiY do tabY#w
(setq sel#w nil
	sel#w (ssget "x" (list 
                       (cons -4 "<AND")
			     (cons 0 "TEXT") (cons 8 "KANT1")  
                       (cons -4 "AND>") )))
(setq tabY#w '() i#w 0)
(repeat (sslength sel#w)
        (progn
	  (setq p#w (cdr (assoc 11 (entget (ssname sel#w i#w))))
              p#w (list (car p#w) (cadr p#w)))

        (setq tabY#w (append tabY#w (list (list 
	               (cdar (cdadr (assoc -3 (entget (ssname sel#w i#w) '("WYNIK_W")))))
			    p#w  ))))
        (setq i#w (+ i#w 1))
));progn/repeat
(setq tabY#w (reverse tabY#w) tab#w tabY#w)

;kontrola czy kolejno podawania punktw bya prawidowa
(while tab#w (progn
	(if (and (car tab#w)(cadr tab#w)
	         (>= (atof (caar tab#w)) (atof (caadr tab#w)) ))
	         (progn (alert (strcat "Niewaciwa kolejno punktw w " 
			           (caar tab#w) " " (caadr tab#w) )) (exit)));if
(setq tab#w (cdr tab#w)) ))


;(print tabX#w)
;(print "---")
;(print Wyd#w)
;(print "---")
;(print tabY#w)


	;tworzenie tablicy zalenoci
	(foreach i#w tabX#w
	(foreach j#w Wyd#w
      (progn
		(command "_UCS" "_3" (cadr i#w) (cadr j#w) "")
	      (setq p#w (trans (list dlugosc_linii_k#w 0) 1 0))
		(command "_UCS" "_p") 
  
			(setq tab#w tabY#w  pp#w nil)
			(while (and (> (length tab#w) 1)
			            (not (setq pp#w (inters (cadr i#w) p#w 
					     (cadr (car  tab#w)) (cadr (cadr tab#w)) )) ))
				 	(setq tab#w (cdr tab#w)) )

		(if pp#w (progn 

			   (print (car i#w))
			   (print (car j#w))
					(setq a#w (car (car  tab#w)) 
						b#w (car (cadr tab#w)) )
			   (print a#w)
                     (print b#w)
			   (print "----")                      
		(command "_LINE" (cadr i#w) p#w "")
		(command "_LINE" (cadr (car  tab#w))
				     (cadr (cadr tab#w)) "")


                     ));progn/if     

		)));progn/foreach/foreach


(princ)
);defun








;specjalnie do porzdkowania danych z c:Szu typu "100-80" "250-200"
(defun c:szu1 ( / i#w max#w p#w)

;(setq x#w (list (list "10080" "23" "1.6") (list "100100" "23" "1.6") 
;	          (list "400300" "43" "0.6") (list "400160" "33" "0.7") ))

;(load "C:/!Wentyle/WentyleSpiro/WentyleSpiroRCPL/WentyleSpiroRCPL_zwieksza.lsp")
;(setq x#w (obliczPa1#w))
(setq y#w '())

(print (length x#w))        
(repeat (length x#w)(progn
		(setq max#w (list "0.00" "" ""))
		(foreach i#w x#w (if (and i#w (>= (atof (car i#w)) (atof (car max#w)) ))
                             (setq max#w i#w)
            ))
(setq y#w (append y#w (list max#w))
	x#w (subst nil max#w x#w))
));progn/repeat

(print (length y#w))
(print)

(reverse y#w)

);defun
;teraz zamieni na (reverse y#w) wszystkie (" na (list "
















;----------------------------------------------------------------------------
;narzdziowa, wyszykuje nazwy funkcji klawiaturowych c:... we wskazanym pliku
(defun c:ccc (  / plik#w sc_d#w tablica#w rzad#w id#w i#w j#w p#w tabl#w tabl1#w)

(setq sc_d#w "C:/!Wentyle/"
	plik#w "WentyleSpiro.lsp")

    ;dane z pliku#w ...txt  do tablic#wy
    (setq id#w (open (strcat sc_d#w  plik#w) "r"))
    (setq tablica#w '())
    (while (setq rzad#w (read-line id#w)) (progn
;    (setq rzad#w (read (strcat "(" rzad#w ")")))
    (setq tablica#w (append  tablica#w (list rzad#w)))
                                   ))
    (setq id#w (close id#w))

(setq p#w '())
(foreach i#w  tablica#w 
(progn

(setq p#w i#w)
(while (> (strlen p#w) 1)
(if (= (substr p#w 1 2) "c:")(setq tabl#w (append tabl#w (list p#w))) )
(setq p#w (substr p#w 2))
);while
));progn/foreach i#w
(print tabl#w)


(setq tabl1#w " ")
(foreach i#w  tabl#w 
(progn
(setq p#w "")
(while (and i#w (/= (substr i#w 1 1) " ")) (setq p#w (strcat p#w (substr i#w 1 1))
								     i#w (substr i#w 2)) );while
(setq tabl1#w (strcat tabl1#w p#w " nil "))
));progn foreach i#w

(print tabl1#w)

(princ)
);defun

;(defun niluje#w ()
;;WentyleOkragle.lsp
;(setq c:lukO_90#w nil c:lukO_60#w nil c:lukO_45#w nil c:lukO_30#w nil 
;	c:lukO_alfa#w nil c:kraO1#w nil c:wentO1#w nil c:smb-2#w nil )
;;WentyleSpiro.lsp
;(setq c:sr#w nil c:bl90#w nil c:bl60#w nil c:bl45#w nil c:bl30#w nil 
;	c:bl15#w nil c:bsl90#w nil c:bsfl90#w nil c:bfl90#w nil c:bfl60#w nil c:bfl45#w nil 
;	c:bfl30#w nil c:bfl15#w nil c:bkcl90#w nil c:bbkcl90#w nil c:mbl90#w nil 
;	c:mbfl90#w nil c:rcpl#w nil c:rcfpl#w nil c:rcll#w nil c:rll#w nil c:rel#w nil 
;	c:rfl#w nil c:psl#w nil c:psvl45#w nil c:tstcl#w nil c:tstl#w nil c:tcpl#w nil 
;	c:xcpl#w nil c:tl#w nil c:tcl#w nil c:xl#w nil c:xcl#w nil c:tvl45#w nil 
;	c:xvl45#w nil c:yvl45#w nil c:npl#w nil c:mf#w nil c:snpl#w nil c:sknpl#w nil 
;	c:smfl#w nil c:skmfl#w nil c:ilrl#w nil c:ill#w nil c:esl#w nil c:epf#w nil 
;	c:epfh#w nil c:drl#w nil c:tdrl#w nil c:psdrl#w nil c:dkl#w nil c:dosl#w nil 
;	c:skl#w nil c:dsl#w nil c:dtl#w nil c:dtml#w nil c:dtwl#w nil c:tvtl#w nil 
;	c:tasl#w nil c:tatl#w nil c:dtbl80-315#w nil c:dtbl355-400#w nil 
;	c:dtbl450-630#w nil c:dtfl80-250#w nil c:dtbol100-315#w nil c:dtbcl100-315#w nil 
;	c:dtbol355-630#w nil c:dtbcl355-630#w nil c:tvtbl#w nil c:tatbl#w nil 
;	c:fml#w nil c:fmdl#w nil c:sll#w nil c:slbl#w nil c:slgl100#w nil c:slgl150#w nil 
;	c:slbgl#w nil c:bsll50#w nil c:bsll100#w nil c:rgs#w nil c:rhs#w nil c:vh#w nil 
;	c:smb-2#w nil )
;(princ)
;);defun







;---------------------------------------------
;narzdziowa, dopisuje znaki do rekordw pliku
(defun c:kkk (  / plik#w sc_d#w tablica#w rzad#w id#w i#w p#w)

(setq sc_d#w "C:/!Wentyle/1111/"
	plik#w "tvtbl.txt")

    ;dane z pliku#w ...txt  do tablic#wy
    (setq id#w (open (strcat sc_d#w  plik#w) "r"))
    (setq tablica#w '())
    (while (setq rzad#w (read-line id#w)) (progn
    (setq rzad#w (read (strcat "(" rzad#w ")")))
    (setq tablica#w (append  tablica#w (list rzad#w)))
                                   ))
    (setq id#w (close id#w))


;tablica#w ("1250" "900" "1460") ("1250" "1000" "1510")
; ">" "125" "0.6" "&"
; "  " "140" "0.6" "&"

(setq p#w '())
(foreach i#w  tablica#w 
(progn
(setq p#w (append p#w (list (append (list "  ") i#w (list "&"))) ))
));progn/foreach
(setq tablica#w p#w)

    (setq id#w (open (strcat sc_d#w  plik#w) "w"))
    (foreach i#w tablica#w
    (progn
    (if (nth 0 i#w) (setq rzad#w (strcat "\042" (nth 0 i#w) "\042 ")))
    (if (nth 1 i#w) (setq rzad#w (strcat rzad#w "\042" (nth 1 i#w) "\042 ")))
    (if (nth 2 i#w) (setq rzad#w (strcat rzad#w "\042" (nth 2 i#w) "\042 ")))
    (if (nth 3 i#w) (setq rzad#w (strcat rzad#w "\042" (nth 3 i#w) "\042 ")))
    (if (nth 4 i#w) (setq rzad#w (strcat rzad#w "\042" (nth 4 i#w) "\042 ")))
    (if (nth 5 i#w) (setq rzad#w (strcat rzad#w "\042" (nth 5 i#w) "\042 ")))
    (if (nth 6 i#w) (setq rzad#w (strcat rzad#w "\042" (nth 6 i#w) "\042 ")))
    (if (nth 7 i#w) (setq rzad#w (strcat rzad#w "\042" (nth 7 i#w) "\042 ")))
    (if (nth 8 i#w) (setq rzad#w (strcat rzad#w "\042" (nth 8 i#w) "\042 ")))
    (if (nth 9 i#w) (setq rzad#w (strcat rzad#w "\042" (nth 9 i#w) "\042 ")))
    (if (nth 10 i#w) (setq rzad#w (strcat rzad#w "\042" (nth 10 i#w) "\042 ")))
    (if (nth 11 i#w) (setq rzad#w (strcat rzad#w "\042" (nth 10 i#w) "\042 ")))
    (if (nth 12 i#w) (setq rzad#w (strcat rzad#w "\042" (nth 10 i#w) "\042 ")))

    (write-line rzad#w id#w)
    ))
    (setq id#w (close id#w))              

(prompt "\nOK!")
);defun





